export interface TtnMessage {
  end_device_ids: {
    device_id: string;
    application_ids: {
      application_id: string;
    };
    dev_eui: string;
    join_eui: string;
    dev_addr?: string;
  };
  correlation_ids: string[];
  received_at: string;
  uplink_message: {
    session_key_id?: string;
    f_port?: number;
    f_cnt?: number;
    frm_payload?: string;
    decoded_payload?: {
      err: number;
      messages: Array<
        [
          {
            measurementId: "4200";
            measurementValue: any[];
            motionId?: number;
            timestamp?: number;
            type: "Event Status";
          },
          {
            measurementId: "5001";
            measurementValue: {
              mac: string;
              rssi: number;
            }[];
            motionId?: number;
            timestamp?: number;
            type: "Wi-Fi Scan";
          },
          {
            measurementId: "3000";
            measurementValue: number;
            motionId?: number;
            timestamp?: number;
            type: "Battery";
          },
          {
            measurementId: "4197";
            measurementValue: number;
            motionId?: number;
            timestamp?: number;
            type: "Longitude";
          },
          {
            measurementId: "4198";
            measurementValue: number;
            motionId?: number;
            timestamp?: number;
            type: "Latitude";
          }
        ]
      >;
      payload: string;
      valid: boolean;
    };
    rx_metadata: {
      gateway_ids: {
        gateway_id: string;
        eui?: string;
      };
      time?: string;
      timestamp?: number;
      rssi: number;
      channel_rssi: number;
      snr?: number;
      location?: {
        latitude: number;
        longitude: number;
        altitude?: number;
        source?: string;
      };
      uplink_token?: string;
      channel_index?: number;
      received_at?: string;
    }[];
    settings: {
      data_rate: {
        lora: {
          bandwidth: number;
          spreading_factor: number;
          coding_rate?: string;
        };
      };
      frequency: string;
      timestamp?: number;
      time?: Date;
    };
    received_at?: Date;
    confirmed?: boolean;
    consumed_airtime?: string;
    version_ids?: {
      brand_id: string;
      model_id: string;
      hardware_version: string;
      firmware_version: string;
      band_id: string;
    };
    network_ids?: {
      net_id: string;
      ns_id: string;
      tenant_id: string;
      cluster_id: string;
      cluster_address: string;
    };
  };
}
