import { DataTypes, Model } from "sequelize";
import { sequelize } from "../database/database";

export class WifiLocationHistory extends Model {
  public wifi_location_history_id!: string;
  public mac!: string;
  public latitude!: number;
  public longitude!: number;
  public created_at_utc!: Date;
  public updated_at_utc!: Date;
}

WifiLocationHistory.init(
  {
    wifi_location_history_id: {
      type: DataTypes.UUID,
      defaultValue: DataTypes.UUIDV4,
      primaryKey: true,
      allowNull: false,
    },
    mac: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    latitude: {
      type: DataTypes.NUMBER,
      allowNull: false,
    },
    longitude: {
      type: DataTypes.NUMBER,
      allowNull: false,
    },
    created_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
    updated_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
  },
  {
    sequelize,
    modelName: "WifiLocationHistory",
    tableName: "wifi_location_history",
    timestamps: false,
  }
);
