import { Attributes, FindOptions } from "sequelize";
import { injectable } from "tsyringe";
import { WifiLocationHistory } from "../models/wifiLocationHistory";

@injectable()
export class WifiLocationHistoryRepository {
  public async findAll() {
    return await WifiLocationHistory.findAll();
  }

  public async findOne(options?: FindOptions<Attributes<WifiLocationHistory>>) {
    return await WifiLocationHistory.findOne(options);
  }

  public async findById(id: string) {
    return await WifiLocationHistory.findByPk(id);
  }

  public async create(data: Partial<WifiLocationHistory>) {
    return await WifiLocationHistory.create(data);
  }

  public async createMany(data: Partial<WifiLocationHistory>[]) {
    return await WifiLocationHistory.bulkCreate(data);
  }
}
